# Generated by Django 2.2.17 on 2021-06-02 19:58

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import enumfields.fields
import filer.fields.image
import jsonfield.fields
import parler.fields
import parler.models
import shuup.core.fields
import shuup.utils.analog


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        migrations.swappable_dependency(settings.FILER_IMAGE_MODEL),
        ('shuup', '0084_tracking_url'),
        ('canvas', '0003_add_canvas_pickup_stock_component'),
    ]

    operations = [
        migrations.CreateModel(
            name='SustainabilityGoal',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('identifier', shuup.core.fields.InternalIdentifierField(blank=True, editable=False, max_length=64, null=True, unique=True)),
                ('image', filer.fields.image.FilerImageField(blank=True, help_text='Supply the SDG image.', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='sdg_images', to=settings.FILER_IMAGE_MODEL, verbose_name='image')),
            ],
            options={
                'abstract': False,
            },
            bases=(parler.models.TranslatableModelMixin, models.Model),
        ),
        migrations.CreateModel(
            name='VendorSustainabilityGoals',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('goals', models.ManyToManyField(blank=True, related_name='vendor_sustainability_goals', to='canvas.SustainabilityGoal', verbose_name='vendors')),
                ('vendor', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='vendor_sustainability_goals', to='shuup.Supplier')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SustainabilityGoalLogEntry',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_on', models.DateTimeField(auto_now_add=True, verbose_name='created on')),
                ('message', models.CharField(max_length=1024, verbose_name='message')),
                ('identifier', models.CharField(blank=True, db_index=True, max_length=256, verbose_name='identifier')),
                ('kind', enumfields.fields.EnumIntegerField(default=0, enum=shuup.utils.analog.LogEntryKind, verbose_name='log entry kind')),
                ('extra', jsonfield.fields.JSONField(blank=True, null=True, verbose_name='extra data')),
                ('target', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='log_entries', to='canvas.SustainabilityGoal', verbose_name='target')),
                ('user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to=settings.AUTH_USER_MODEL, verbose_name='user')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ProductSustainabilityGoals',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('goals', models.ManyToManyField(blank=True, related_name='project_sustainability_goals', to='canvas.SustainabilityGoal', verbose_name='projects')),
                ('product', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='project_sustainability_goals', to='shuup.ShopProduct')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='canvassupplierextra',
            name='sustainability_goals_fk',
            field=models.ManyToManyField(blank=True, help_text="Which United Nations' Sustainable Development Goals does your brand address?", related_name='canvas_extra_sustainability_goals', to='canvas.SustainabilityGoal', verbose_name='Sustainable Development Goals'),
        ),
        migrations.CreateModel(
            name='SustainabilityGoalTranslation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('language_code', models.CharField(db_index=True, max_length=15, verbose_name='Language')),
                ('name', models.CharField(help_text='Choose your Sustainable Development Goals (SDGs).', max_length=64, verbose_name='name')),
                ('description', models.CharField(help_text='Describe the SDG.', max_length=256, verbose_name='description')),
                ('master', parler.fields.TranslationsForeignKey(editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='translations', to='canvas.SustainabilityGoal')),
            ],
            options={
                'verbose_name': 'sustainability goal Translation',
                'db_table': 'canvas_sustainabilitygoal_translation',
                'db_tablespace': '',
                'managed': True,
                'default_permissions': (),
                'unique_together': {('language_code', 'master')},
            },
            bases=(parler.models.TranslatedFieldsModelMixin, models.Model),
        ),
    ]
